<?php
/*
 * DasForum - a PHP BulletinBoardSystem
 * Copyright 2007 Heiko Rothkranz <heiko_rothkranz (at) arcor (dot) de>
 * 
 * This file is part of DasForum
 * 
 * DasForum is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * DasForum is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with DasForum; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

if(isset($_GET["type"]) and $_GET["type"] == "install")
{
	$spalten = array(
		"id"               => array("typ" => "bigint",   "size" => 20,   "unsigned" => true,  "NULL" => false, "auto" => true,  "default" => NULL),
		"titel"            => array("typ" => "varchar",  "size" => 255,  "unsigned" => false, "NULL" => false, "auto" => false, "default" => "''"),
		"beschreibung"     => array("typ" => "varchar",  "size" => 255,  "unsigned" => false, "NULL" => true,  "auto" => false, "default" => NULL),
		"besitzer_id"      => array("typ" => "bigint",   "size" => 20,   "unsigned" => true,  "NULL" => false, "auto" => false, "default" => NULL),
		"besitzer_name"    => array("typ" => "varchar",  "size" => 255,  "unsigned" => false, "NULL" => false, "auto" => false, "default" => "''"),
		"privat"           => array("typ" => "tinyint",  "size" => 1,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"KEY1"             => array("typ" => "PRIMARY",  "spalte" => "id")
	);
	sql_createtable("kalender_kalender", $spalten);
	
	$spalten = array(
		"gruppe_id"        => array("typ" => "bigint",   "size" => 20,   "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"kalender_id"      => array("typ" => "bigint",   "size" => 20,   "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"lesen"            => array("typ" => "tinyint",  "size" => 1,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"schreiben"        => array("typ" => "tinyint",  "size" => 1,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"moderieren"       => array("typ" => "tinyint",  "size" => 1,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0)
	);
	sql_createtable("kalender_rechte", $spalten);
	
	$spalten = array(
		"id"               => array("typ" => "bigint",   "size" => 20,   "unsigned" => true,  "NULL" => false, "auto" => true,  "default" => NULL),
		"titel"            => array("typ" => "varchar",  "size" => 255,  "unsigned" => false, "NULL" => false, "auto" => false, "default" => "''"),
		"beschreibung"     => array("typ" => "text",     "size" => NULL, "unsigned" => false, "NULL" => true,  "auto" => false, "default" => NULL),
		"kalender"         => array("typ" => "bigint",   "size" => 20,   "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"autor_id"         => array("typ" => "bigint",   "size" => 20,   "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"autor_name"       => array("typ" => "varchar",  "size" => 255,  "unsigned" => false, "NULL" => false, "auto" => false, "default" => "''"),
		"tag"              => array("typ" => "tinyint",  "size" => 2,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"monat"            => array("typ" => "tinyint",  "size" => 2,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"jahr"             => array("typ" => "smallint", "size" => 5,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"endetag"          => array("typ" => "tinyint",  "size" => 2,    "unsigned" => true,  "NULL" => true,  "auto" => false, "default" => NULL),
		"endemonat"        => array("typ" => "tinyint",  "size" => 2,    "unsigned" => true,  "NULL" => true,  "auto" => false, "default" => NULL),
		"endejahr"         => array("typ" => "smallint", "size" => 5,    "unsigned" => true,  "NULL" => true,  "auto" => false, "default" => NULL),
		"rangedtag"        => array("typ" => "tinyint",  "size" => 2,    "unsigned" => true,  "NULL" => true,  "auto" => false, "default" => NULL),
		"rangedmonat"      => array("typ" => "tinyint",  "size" => 2,    "unsigned" => true,  "NULL" => true,  "auto" => false, "default" => NULL),
		"rangedjahr"       => array("typ" => "smallint", "size" => 5,    "unsigned" => true,  "NULL" => true,  "auto" => false, "default" => NULL),
		"wiederholung"     => array("typ" => "tinyint",  "size" => 1,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"created"          => array("typ" => "int",      "size" => 10,   "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"bbcode"           => array("typ" => "tinyint",  "size" => 1,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"smilies"          => array("typ" => "tinyint",  "size" => 1,    "unsigned" => true,  "NULL" => false, "auto" => false, "default" => 0),
		"KEY1"             => array("typ" => "PRIMARY",  "spalte" => "id")
		);
	sql_createtable("kalender_events", $spalten);
	
	// Allgemeinen Kalender hinzufgen
	$werte = array(
		"titel"            => "Allgemeiner Kalender",
		"beschreibung"     => "Allgemeine Events",
		"besitzer_id"      => 2,
		"besitzer_name"    => "Admin",
		"privat"           => 0
	);
	sql_insert("kalender_kalender", $werte);
	
	// Standard-Kalenderrechte hinzufgen
	$werte = array(
		"gruppe_id"      => 1,
		"kalender_id"    => 1,
		"lesen"          => 1,
		"schreiben"      => 0,
		"moderieren"     => 0
	);
	sql_insert("kalender_rechte", $werte);
	
	$werte = array(
		"gruppe_id"      => 2,
		"kalender_id"    => 1,
		"lesen"          => 1,
		"schreiben"      => 0,
		"moderieren"     => 0
	);
	sql_insert("kalender_rechte", $werte);
	
	$werte = array(
		"gruppe_id"      => 3,
		"kalender_id"    => 1,
		"lesen"          => 1,
		"schreiben"      => 1,
		"moderieren"     => 1
	);
	sql_insert("kalender_rechte", $werte);
	
	$werte = array(
		"gruppe_id"      => 4,
		"kalender_id"    => 1,
		"lesen"          => 1,
		"schreiben"      => 1,
		"moderieren"     => 1
	);
	sql_insert("kalender_rechte", $werte);
}
elseif(isset($_POST["deinstallieren_bestaetigen"]))
{
	sql_drop_table("kalender_kalender");
	sql_drop_table("kalender_rechte");
	sql_drop_table("kalender_events");
}
?>